Summary:     The server programs for Kerberos 5
Name:        krb5
Version:     1.4
Release:     4.pp
License:     MIT, freely distributable
Group:       System Environment/Daemons
Source0:     http://web.mit.edu/kerberos/dist/%{name}/%{version}/%{name}-%{version}.tar.gz
Source1:     krb5.conf
Source2:     kdc.conf
Source3:     kadm5.acl
Source4:     krb5.sh.profile
Source5:     krb5.csh.profile
Source6:     kadmin.init
Source7:     kdcrotate.init
Source8:     kprop.init
Source9:     krb524.init
Source10:    krb5kdc.init
Source11:    eklogin.xinetd
Source12:    gssftp.xinetd
Source13:    klogin.xinetd
Source14:    krb5-telnet.xinetd
Source15:    kshell.xinetd
URL:         http://web.mit.edu/kerberos/www/
Buildroot:   /var/tmp/%{name}-root
Packager:    Peter Pramberger <peter.pramberger@member.fsf.org>
Requires:    %{name}-libs = %{version}-%{release} %{name}-libs.pp
Provides:    %{name}.pp
Prereq:      /bin/bash /sbin/ldconfig /bin/grep
BuildPrereq: gcc >= 2.96 /bin/mkdir /usr/bin/make /usr/bin/install
BuildPrereq: glibc-devel
ExclusiveOS: linux

%description
Kerberos is a network authentication system. The %{name}
package contains the programs that must be installed on
a Kerberos 5 server. If you are installing a Kerberos 5
server, you need to install this package.


%package devel
Summary:     Development tools for Kerberos 5
Group:       Development/Libraries
Requires:    %{name}-libs = %{version}-%{release} %{name}-libs.pp
Provides:    %{name}-devel.pp

%package libs
Summary:     The shared libraries used by Kerberos 5
Group:       System Environment/Libraries
Requires:    glibc
Provides:    %{name}-libs.pp

%package client
Summary:     Kerberos 5 programs for use on workstations
Group:       Environment/Console
Requires:    %{name}-libs = %{version}-%{release} %{name}-libs.pp
Requires:    libtermcap
Conflicts:   krb5-workstation
Provides:    %{name}-client.pp


%description devel
The %{name}-devel package contains the static libraries
and header files for developing software for Kerberos 5.

%description client
Kerberos is a network authentication system. The %{name}-client
package contains the basic Kerberos programs (kinit, klist,
kdestroy, kpasswd) as well as kerberized versions of Telnet
and FTP. If your network uses Kerberos, this package should be
installed on every workstation.

%description libs
Kerberos is a network authentication system. The %{name}-libs
package contains the shared libraries needed by Kerberos 5. If
you are using Kerberos, you need to install this package.


%prep
%setup -q
# prepare docs
mv doc/api .
mv doc/implement .
mv doc/kadm5 .
mv doc/kadmin .
mv doc/krb5-protocol .
mv doc/rpc .


%build
export CFLAGS="$RPM_OPT_FLAGS"
cd src
./configure \
	--prefix=/usr/kerberos    \
	--sysconfdir=/etc         \
	--localstatedir=/var/kerberos \
	--mandir=/usr/share/man   \
	--enable-dns-for-realm    \
	--enable-static           \
	--enable-shared           \
	--enable-ipv6             \
	--enable-kdc-replay-cache \
	--with-krb4               \
	--with-kdc-kdb-update     \
	--without-tcl
make all


# Do not strip, only compress documentation
%define __os_install_post /usr/lib/rpm/brp-compress


%install
cd src
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/etc/profile.d
mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d
mkdir -p $RPM_BUILD_ROOT/usr
mkdir -p $RPM_BUILD_ROOT/var/kerberos/krb5kdc
make \
	DESTDIR=$RPM_BUILD_ROOT \
	install
chmod a+x $RPM_BUILD_ROOT/usr/kerberos/lib/*.so.*
ldconfig -n $RPM_BUILD_ROOT/usr/kerberos/lib
mv $RPM_BUILD_ROOT/usr/kerberos/share/gnats $RPM_BUILD_ROOT/usr/share/gnats
rm -rf $RPM_BUILD_ROOT/usr/kerberos/share
# install configs
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT/etc
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT/var/kerberos/krb5kdc
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT/var/kerberos/krb5kdc
install -m 755 %{SOURCE4} $RPM_BUILD_ROOT/etc/profile.d/krb5.sh
install -m 755 %{SOURCE5} $RPM_BUILD_ROOT/etc/profile.d/krb5.csh
install -m 755 %{SOURCE6} $RPM_BUILD_ROOT/etc/rc.d/init.d/kadmin
install -m 755 %{SOURCE7} $RPM_BUILD_ROOT/etc/rc.d/init.d/kdcrotate
install -m 755 %{SOURCE8} $RPM_BUILD_ROOT/etc/rc.d/init.d/kprop
install -m 755 %{SOURCE9} $RPM_BUILD_ROOT/etc/rc.d/init.d/krb524
install -m 755 %{SOURCE10} $RPM_BUILD_ROOT/etc/rc.d/init.d/krb5kdc
install -m 644 %{SOURCE11} $RPM_BUILD_ROOT/etc/xinetd.d/eklogin
install -m 644 %{SOURCE12} $RPM_BUILD_ROOT/etc/xinetd.d/gssftp
install -m 644 %{SOURCE13} $RPM_BUILD_ROOT/etc/xinetd.d/klogin
install -m 644 %{SOURCE14} $RPM_BUILD_ROOT/etc/xinetd.d/krb5-telnet
install -m 644 %{SOURCE15} $RPM_BUILD_ROOT/etc/xinetd.d/kshell
# prevent name clashes
mv $RPM_BUILD_ROOT/usr/share/man/man1/ftp.1 $RPM_BUILD_ROOT/usr/share/man/man1/kftp.1
mv $RPM_BUILD_ROOT/usr/share/man/man1/telnet.1 $RPM_BUILD_ROOT/usr/share/man/man1/ktelnet.1
mv $RPM_BUILD_ROOT/usr/share/man/man8/telnetd.8 $RPM_BUILD_ROOT/usr/share/man/man8/ktelnetd.8


%post
if [ $1 = 1 ]; then
  /sbin/chkconfig --add kadmin
  /sbin/chkconfig kadmin off
  /sbin/chkconfig --add kprop
  /sbin/chkconfig kprop off
  /sbin/chkconfig --add krb524
  /sbin/chkconfig krb524 off
  /sbin/chkconfig --add krb5kdc
  /sbin/chkconfig krb5kdc off
else
  if [ -f /var/lock/subsys/kadmin ]; then
    /etc/rc.d/init.d/kadmin restart
  fi
  if [ -f /var/lock/subsys/kprop ]; then
    /etc/rc.d/init.d/kprop restart
  fi
  if [ -f /var/lock/subsys/krb524 ]; then
    /etc/rc.d/init.d/krb524 restart
  fi
  if [ -f /var/lock/subsys/krb5kdc ]; then
    /etc/rc.d/init.d/krb5kdc restart
  fi
fi

%post libs
if ! grep "/usr/kerberos/lib" /etc/ld.so.conf > /dev/null 2>&1; then
  echo "/usr/kerberos/lib" >> /etc/ld.so.conf
fi
/sbin/ldconfig
# Add services
if ! grep kerberos /etc/services >/dev/null 2>&1; then
   echo -e "kerberos\t88/tcp\t\tkdc" >> /etc/services
   echo -e "kerberos\t88/udp\t\tkdc" >> /etc/services
fi
if ! grep kerberos-sec /etc/services >/dev/null 2>&1; then
   echo -e "kerberos-sec\t750/tcp" >> /etc/services
   echo -e "kerberos-sec\t750/udp" >> /etc/services
fi
if ! grep kerberos_master /etc/services >/dev/null 2>&1; then
   echo -e "kerberos_master\t751/tcp" >> /etc/services
   echo -e "kerberos_master\t751/udp" >> /etc/services
fi
if ! grep kerberos-adm /etc/services >/dev/null 2>&1; then
   echo -e "kerberos-adm\t749/tcp" >> /etc/services
   echo -e "kerberos-adm\t749/udp" >> /etc/services
fi
if ! grep kpop /etc/services >/dev/null 2>&1; then
   echo -e "kpop\t\t1109/tcp" >> /etc/services
fi
if ! grep kshell /etc/services >/dev/null 2>&1; then
   echo -e "kshell\t\t544/tcp\t\tcmd" >> /etc/services
fi
if ! grep klogin /etc/services >/dev/null 2>&1; then
   echo -e "klogin\t\t543/tcp" >> /etc/services
fi
if ! grep eklogin /etc/services >/dev/null 2>&1; then
   echo -e "eklogin\t\t2105/tcp" >> /etc/services
fi
if ! grep krb5_prop /etc/services >/dev/null 2>&1; then
   echo -e "krb5_prop\t754/tcp" >> /etc/services
fi
if ! grep krb524 /etc/services >/dev/null 2>&1; then
   echo -e "krb524\t\t4444/tcp" >> /etc/services
fi


%preun
if [ $1 = 0 ]; then
  /sbin/chkconfig --del kadmin
  /sbin/chkconfig --del kprop
  /sbin/chkconfig --del krb524
  /sbin/chkconfig --del krb5kdc
  if [ -f /var/lock/subsys/kadmin ]; then
    /etc/rc.d/init.d/kadmin stop
  fi
  if [ -f /var/lock/subsys/kprop ]; then
    /etc/rc.d/init.d/kprop stop
  fi
  if [ -f /var/lock/subsys/krb524 ]; then
    /etc/rc.d/init.d/krb524 stop
  fi
  if [ -f /var/lock/subsys/krb5kdc ]; then
    /etc/rc.d/init.d/krb5kdc stop
  fi
fi


%postun libs
if [ $1 = 0 ]; then
  grep -v "/usr/kerberos/lib" /etc/ld.so.conf > tmpfile
  cat tmpfile > /etc/ld.so.conf; rm -f tmpfile
fi
/sbin/ldconfig


%clean
rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc doc/krb425.html doc/krb5-admin.html doc/krb5-install.html
%doc doc/admin-guide.ps doc/install-guide.ps doc/krb425-guide.ps
/etc/rc.d/init.d/*
/usr/kerberos/bin/sclient
/usr/kerberos/sbin/kadmin.local
/usr/kerberos/sbin/kadmind
/usr/kerberos/sbin/k5srvutil
/usr/kerberos/sbin/kdb5_util
/usr/kerberos/sbin/kprop*
/usr/kerberos/sbin/krb524d
/usr/kerberos/sbin/krb5kdc
/usr/kerberos/sbin/sim_server
/usr/kerberos/sbin/sserver
/usr/share/man/man1/sclient*
/usr/share/man/man5/kdc.conf*
/usr/share/man/man8/kadmin.local*
/usr/share/man/man8/kadmind*
/usr/share/man/man8/k5srvutil*
/usr/share/man/man8/kdb5_util*
/usr/share/man/man8/kprop*
/usr/share/man/man8/krb524d*
/usr/share/man/man8/krb5kdc*
/usr/share/man/man8/sserver*
%dir /var/kerberos
%dir %attr(700,root,root) /var/kerberos/krb5kdc
%config(noreplace) /var/kerberos/krb5kdc/*

%files devel
%defattr(-,root,root)
%doc %dir api implement kadm5 kadmin krb5-protocol rpc
%doc doc/thread-safe.txt doc/threads.txt doc/ChangeLog
%doc doc/procedures.txt doc/coding-style
/usr/kerberos/bin/krb5-config
/usr/kerberos/include/*
/usr/kerberos/lib/*.*a
/usr/kerberos/lib/*.so
/usr/share/man/man1/krb5-config*

%files libs
%defattr(-,root,root)
%doc README
%config(noreplace) /etc/krb5.conf
%dir /usr/kerberos
/usr/kerberos/lib/*.so.*
/usr/share/gnats/*
/usr/share/man/man5/krb5.conf*
/usr/share/man/man5/.k5login*

%files client
%defattr(-,root,root)
%doc doc/ftp.html doc/kdestroy.html doc/kinit.html doc/klist.html
%doc doc/kpasswd.html doc/krb5-user.html doc/ksu.html doc/rcp.html
%doc doc/rlogin.html doc/rsh.html doc/telnet.html doc/user-guide.ps
%config(noreplace) /etc/profile.d/*
%config(noreplace) /etc/xinetd.d/*
/usr/kerberos/bin/ftp
/usr/kerberos/bin/gss-client
/usr/kerberos/bin/kdestroy
/usr/kerberos/bin/kinit
/usr/kerberos/bin/klist
/usr/kerberos/bin/kpasswd
/usr/kerberos/bin/krb524init
/usr/kerberos/bin/ksu
/usr/kerberos/bin/kvno
/usr/kerberos/bin/rcp
/usr/kerberos/bin/rlogin
/usr/kerberos/bin/rsh
/usr/kerberos/bin/sim_client
/usr/kerberos/bin/telnet
/usr/kerberos/bin/uuclient
/usr/kerberos/bin/v4rcp
/usr/kerberos/sbin/ftpd
/usr/kerberos/sbin/gss-server
/usr/kerberos/sbin/kadmin
/usr/kerberos/sbin/klogind
/usr/kerberos/sbin/krb5-send-pr
/usr/kerberos/sbin/kshd
/usr/kerberos/sbin/ktutil
/usr/kerberos/sbin/login.krb5
/usr/kerberos/sbin/telnetd
/usr/kerberos/sbin/uuserver
/usr/share/man/man1/krb5-send-pr*
/usr/share/man/man1/kftp*
/usr/share/man/man1/kdestroy*
/usr/share/man/man1/kinit*
/usr/share/man/man1/klist*
/usr/share/man/man1/kpasswd*
/usr/share/man/man1/ksu*
/usr/share/man/man1/kvno*
/usr/share/man/man1/rcp*
/usr/share/man/man1/rlogin*
/usr/share/man/man1/rsh*
/usr/share/man/man1/ktelnet*
/usr/share/man/man1/v4rcp*
/usr/share/man/man1/kerberos*
/usr/share/man/man8/kshd*
/usr/share/man/man8/ktelnetd*
/usr/share/man/man8/login.krb5*
/usr/share/man/man8/ftpd*
/usr/share/man/man8/kadmin*
/usr/share/man/man8/klogind*
/usr/share/man/man8/ktutil*


%changelog
* Mon Mar 21 2005 peter.pramberger@member.fsf.org
- created

